import java.util.HashSet;


/**
 *
 * <p>Title: JAS</p>
 * <p>Description: Java Agent-based Simulation library</p>
 * <p>Copyright (C) 2002 Michele Sonnessa</p>
 *
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation;
 * either version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 * 
 * @author Michele Sonnessa
 * 
 */
public class FileTransfer {

	private Device target;
	private HashSet path;
	public int failed;
	public int packetsToSend;
	public int reconnections = 0;
	 
	public FileTransfer(Device target, int packetsToSend)
	{
		this.target = target;
		path = new HashSet();
		this.packetsToSend = packetsToSend;
	}	
	
	
	public int getHops()
	{
		return path.size();
	}
		
	public void beginRoute()
	{
		path.clear();
	}
		
	public void routeCompleted()
	{
		packetsToSend--;
		failed = 0;
	}
		
	public void routeFailed()
	{
		failed++;
	}
				
	public void hopOnNode(Device device)
	{
		path.add(device);
	}

	public boolean hasVisited(Device device)
	{
		return path.contains(device);
	}

	/**
	 * @return
	 */
	public Device getTarget() {
		return target;
	}

	/**
	 * @return
	 */
	public int getPacketsToSend() {
		return packetsToSend;
	}

	/**
	 * @return
	 */
	public int getFailed() {
		return failed;
	}

	/**
	 * @return
	 */
	public HashSet getPath() {
		return path;
	}

}
